﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace 全民k歌全自动监控工具
{
    public partial class Form1 : Form
    {
        private int tMax = -1;//最大时间戳
        //查询链接
        private const string CGI = "http://cgi.kg.qq.com/fcgi-bin/kg_ugc_get_homepage?jsonpCallback=callback_0&inCharset=GB2312&outCharset=utf-8&g_tk=5381&g_tk_openkey=5381&type=get_uinfo&start=1&num=8&touin=&share_uid=";
        private int count = 1;//次数
        private const string BAIDU = "https://voice.baidu.com/act/newpneumonia/newpneumonia#tab0";//百度
        private const string SOUGOU = "http://sa.sogou.com/new-weball/page/sgs/epidemic?type_page=VR";//搜狗
        private const string XINLANG = "https://news.sina.cn/zt_d/yiqing0121?ncovArticleEntrance=1";//新浪
        private const string WANGYI = "http://news.163.com/special/epidemic/";//网易
        private int confirmed;//确诊
        private int unconfirmed;//疑似
        private int cured;//治愈
        private int died;//死亡
        private string priUid = null;
        private string priRemark = null;
        private enum Source { Baidu, Sougou, Xinlang, Wangyi };//疫情信息来源

        /// <summary>
        /// Form1默认构造
        /// </summary>
        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Form1有参构造
        /// </summary>
        /// <param name="priUid">歌手uid</param>
        public Form1(string priUid)
        {
            this.priUid = priUid;
            InitializeComponent();
        }
        /// <summary>
        /// Form1有参构造
        /// </summary>
        /// <param name="priUid">歌手uid</param>
        /// <param name="priRemark">歌手备注</param>
        public Form1(string priUid, string priRemark)
        {
            this.priUid = priUid;
            this.priRemark = priRemark;
            InitializeComponent();
        }

        /// <summary>
        /// 获取网页源码
        /// </summary>
        /// <param name="url">url</param>
        /// <returns></returns>
        private static string GetS(string url)
        {
            string message = string.Empty;
            HttpWebRequest request;
            try
            {
                request = (HttpWebRequest)WebRequest.Create(url);
                request.Accept = "text/html, application/xhtml+xml, */*";
                request.UserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)";
                request.KeepAlive = true;
                request.ProtocolVersion = HttpVersion.Version11;
                ServicePointManager.Expect100Continue = false;
                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                Stream responseStream = response.GetResponseStream();
                StreamReader reader = new StreamReader(responseStream, Encoding.GetEncoding("UTF-8"));
                message = reader.ReadToEnd();
                reader.Close();
                responseStream.Close();
            }
            catch (Exception err)
            {
                message = err.Message;
            }
            finally { GC.Collect(); }
            return message;
        }

        /// <summary>
        /// 获取网页源码
        /// </summary>
        /// <param name="url"></param>
        /// <param name="en">编码</param>
        /// <returns></returns>
        public static string GetS(string url, Encoding en)
        {
            string message = string.Empty;
            HttpWebRequest request;
            try
            {
                request = (HttpWebRequest)WebRequest.Create(url);
                request.Accept = "text/html, application/xhtml+xml, */*";
                request.UserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)";
                request.KeepAlive = true;
                request.ProtocolVersion = HttpVersion.Version11;
                ServicePointManager.Expect100Continue = false;
                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                Stream responseStream = response.GetResponseStream();
                StreamReader reader = new StreamReader(responseStream, en);
                message = reader.ReadToEnd();
                reader.Close();
                responseStream.Close();
            }
            catch (Exception err)
            {
                message = err.Message;
            }
            finally { GC.Collect(); }
            return message;
        }

        /// <summary>
        /// 下载文件，若目标已存在则覆盖，文件名非法则不会下载
        /// </summary>
        /// <param name="path">目录</param>
        /// <param name="url">下载地址</param>
        [DllImport("Wesing.dll")]
        private static extern void Down(string path, string url);

        /// <summary>
        /// 取出中间字符串
        /// </summary>
        /// <param name="str">源字符串</param>
        /// <param name="leftStr">左</param>
        /// <param name="rightStr">右</param>
        /// <returns>成功返回结果,失败返回空</returns>
        public static string GetMiddleText(string str, string leftStr, string rightStr)
        {
            if (str == "" || leftStr == "" || rightStr == "") { return null; }
            int a = str.IndexOf(leftStr, 0);
            int b = str.IndexOf(rightStr, a + 1);
            if (a < 0 || b < 0)
            { return null; }
            else
            {
                a = a + leftStr.Length;
                b = b - a;
                if (a < 0 || b < 0)
                { return null; }
                return str.Substring(a, b);
            }
        }

        /// <summary>
        /// 获取最大时间戳
        /// </summary>
        /// <param name="s">源码</param>
        /// <param name="potectTime">受保护的时间戳</param>
        /// <returns>成功则返回时间戳，失败则返回保护的时间戳</returns>
        [DllImport("Wesing.dll")]
        private static extern int GetTime(string s, int potectTime);

        /// <summary>
        /// 获取最新作品链接
        /// </summary>
        /// <param name="源码">源码</param>
        /// <param name="t0">最大时间</param>
        /// <returns></returns>
        [DllImport("Wesing.dll", CharSet = CharSet.Ansi)]
        private static extern IntPtr GetUrl(string s, int t0);
        /// <summary>
        /// 获取最新作品链接
        /// </summary>
        /// <param name="s">源码</param>
        /// <param name="t0">最大时间</param>
        /// <returns>返回最新作品链接</returns>
        private string GetNew(string s, int t0)
        {
            return Marshal.PtrToStringAnsi(GetUrl(s, t0));
        }

        /// <summary>
        /// 字符串转整数
        /// </summary>
        /// <param name="str">字符串</param>
        /// <returns>成功返回结果,失败返回-1</returns>
        private int TriParse(string str)
        {
            try { return int.Parse(str); }
            catch (Exception)
            { return -1; }
        }


        /// <summary>
        /// 下载作品
        /// </summary>
        /// <param name="url">作品链接</param>
        /// <returns></returns>
        private Song Download(string url)
        {
            status.Text = "正在下载中";
            Thread.Sleep(500);
            Random rd = new Random();
            int ctime = tMax;//保护原有时间戳
            try
            {
                string s = GetS(url);
                ctime = int.Parse(GetMiddleText(s, "ctime\":", ",\"f_lat\":"));//时间戳
                string name = GetMiddleText(s, "<h2 class=\"play_name\">", "</h2>");//歌名
                string singer;//歌手名
                if (chkRemark.Checked)
                { singer = txtRemark.Text.Trim(); }//使用备注
                else { singer = GetMiddleText(s, "<title>", "-"); }//不使用备注
                string DownUrl;
                if (s.Contains(".mp4")) { DownUrl = GetMiddleText(s, "playurl_video\":\"", "&fromtag"); }
                else
                { DownUrl = GetMiddleText(s, "playurl\":\"", "&fromtag"); }//下载地址
                string rand = rd.Next().ToString();//生成随机数
                if (File.Exists(string.Format("{0}\\{1}-{2}.m4a", Directory.GetCurrentDirectory(), singer, name)))
                { name += rand; }//目标文件已存在,使用随机数重命名
                Down(string.Format("{0}\\{1}-{2}.m4a", Directory.GetCurrentDirectory(), singer, name), DownUrl);
                if (chkAutoPlay.Checked)//自动播放
                { player.URL = DownUrl; }
                if (!File.Exists(string.Format("{0}\\{1}-{2}.m4a", Directory.GetCurrentDirectory(), singer, name)))
                { //歌手名存在非法字符,启动备用下载
                    Down(string.Format("{0}\\{1}-{2}.m4a", Directory.GetCurrentDirectory(), rand, name), DownUrl);
                    if (!File.Exists(string.Format("{0}\\{1}-{2}.m4a", Directory.GetCurrentDirectory(), rand, name)))
                    {//歌名存在非法字符,启动备用下载
                        Down(string.Format("{0}\\{1}-{2}.m4a", Directory.GetCurrentDirectory(), rand, rd.Next()), DownUrl);
                    }
                }
                status.Text = string.Format("下载成功:{0},时间戳为{1}", name, ctime);
                if (!DownUrl.Contains("http"))
                { status.Text = "下载失败,下载地址有误" + DownUrl; }
                return new Song(name, singer, url, DownUrl, ctime);
            }
            catch (Exception err)
            {
                status.Text = "下载失败," + err.Message;
                return new Song(ctime);
            }
        }

        /// <summary>
        /// 加载图片
        /// </summary>
        /// <param name="url"></param>
        /// <returns></returns>
        private Image GetImage(string url)
        {
            try
            {
                return Image.FromStream(WebRequest.Create(url).GetResponse().GetResponseStream());
            }
            catch (Exception err)
            {//将err.Message转换成图片
                //Graphics gra = new Graphics();
                //return err.Message;
                btnSaveImage.Enabled = false;
                return null;
            }
        }

        /// <summary>
        /// 分离"\"
        /// </summary>
        /// <param name="source">源字符串</param>
        /// <returns></returns>
        private string GetSplit(string source)
        {
            string[] str = source.Split('\\');
            string temp = null;
            foreach (string t in str)
            { temp += t; }
            return temp;
        }

        /// <summary>
        /// 从网上获取疫情信息
        /// </summary>
        private void LoadMessage()
        {
            if (LoadMessage(Source.Baidu))
            { return; }
            if (LoadMessage(Source.Sougou))
            { return; }
            if (LoadMessage(Source.Xinlang))
            { return; }
            if (LoadMessage(Source.Wangyi))
            { return; }
        }

        /// <summary>
        /// 获取信息
        /// </summary>
        /// <param name="source">信息源</param>
        /// <returns>返回是否成功</returns>
        private bool LoadMessage(Source source)
        {
            try
            {
                string s = null;
                switch (source)
                {//summaryDataIn\":{\"confirmed\":\"28130\",\"died\":\"564\",\"cured\":\"1325\",\"unconfirmed\":\"24702\",\"relativeTime
                    case Source.Baidu:
                        s = GetS(BAIDU);//获取源码
                        if (!s.Contains("疫情"))
                        {
                            return false;
                        }
                        string summaryDataIn = GetMiddleText(s, "summaryDataIn", "summaryDataOut");
                        confirmed = int.Parse(GetMiddleText(summaryDataIn, "\"confirmed\":\"", "\",\"died"));
                        unconfirmed = int.Parse(GetMiddleText(summaryDataIn, "unconfirmed\":\"", "\",\"relativeTime"));
                        cured = int.Parse(GetMiddleText(summaryDataIn, "cured\":\"", "\",\"unconfirmed"));
                        died = int.Parse(GetMiddleText(summaryDataIn, "died\":\"", "\",\"cured"));
                        break;
                    case Source.Sougou:
                        s = GetS(SOUGOU, Encoding.UTF8);//获取源码
                        if (!s.Contains("疫情"))
                        {
                            return false;
                        }
                        confirmed = int.Parse(GetMiddleText(s, "\"diagnosed\":", ",\"suspect"));
                        unconfirmed = int.Parse(GetMiddleText(s, "\"suspect\":", ",\"death"));
                        cured = int.Parse(GetMiddleText(s, "\"cured\":", ",\"remark"));
                        died = int.Parse(GetMiddleText(s, "\"death\":", ",\"cured"));
                        break;
                    case Source.Xinlang:
                        s = GetS(XINLANG);//获取源码
                        if (!s.Contains("疫情"))
                        {
                            return false;
                        }
                        int a = 0;
                        a /= a;//新浪不会爬
                        break;
                    case Source.Wangyi:
                        s = GetS(WANGYI, Encoding.Default);//获取源码
                        Console.WriteLine(s);
                        if (!s.Contains("疫情"))
                        {
                            return false;
                        }
                        confirmed = int.Parse(GetMiddleText(s, "<p>中国（含港澳台）：确诊 ", " 例，死亡"));
                        unconfirmed = -1;//网易没有疑似
                        cured = int.Parse(GetMiddleText(s, "治愈 ", " 例</p>"));
                        died = int.Parse(GetMiddleText(s, "，死亡 ", " 例，治愈"));
                        break;
                }
                return true;
            }
            catch (Exception err)
            {
                Console.WriteLine(err.Message);
                return false;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            timerRefresh.Interval = (int)numInterval.Value;
            status.Text = "作者:遗憾迟香";
            status2.Text = null;
            if (priUid != null)
            {
                if (priRemark != null)
                {
                    chkRemark.Checked = true;
                    txtRemark.Text = priRemark;
                }
                Start(priUid);
                txtUid.Text = priUid;
            }
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            Start(txtUid.Text);
        }

        /// <summary>
        /// 开始
        /// </summary>
        /// <param name="uid">歌手uid</param>
        public void Start(string uid)
        {
            priUid = uid;
            status.Text = "正在获取歌手信息";
            try
            {
                string s = GetS(CGI + priUid);
                if (s.Contains("参数错误") || !s.Contains("ok"))
                {
                    status.Text = "请检查网络连接以及输入的uid是否正确";
                    return;
                }
                Thread.Sleep(500);
                string temp = GetSplit(GetMiddleText(s, "head_img_url\": \"", "\","));
                pictureBox.Image = GetImage(temp);
                tMax = GetTime(s, -1);//获取最大时间戳
                lstInfo.Items.Clear();
                lstInfo.Items.Add(GetMiddleText(s, "\"nickname\": \"", "\", \"sCityId"));//昵称
                lstInfo.Items.Add(string.Format("粉丝:{0}", TriParse(GetMiddleText(s, "\"follower\":", ", \"following").Trim())));
                lstInfo.Items.Add(string.Format("关注:{0}", TriParse(GetMiddleText(s, "\"following\":", ", \"friends").Trim())));
                numTMax.Value = tMax;
                txtUid.Enabled = false;
                groupBox3.Enabled = false;
                btnClear.Enabled = false;
                btnPasteUrl.Enabled = false;
                groupBox5.Enabled = false;
                btnStop.Enabled = true;
                numInterval.Enabled = false;
                btnStart.Enabled = false;
                timerRefresh.Start();
                btnSaveImage.Enabled = true;
                status.Text = "已开始";
                LoadMessage();//获取疫情信息
                status2.Text = string.Format("第{0}次监控 确诊:{1} 疑似:{2} 治愈:{3} 死亡:{4} 更新时间:{5}", count, confirmed, unconfirmed, cured, died, DateTime.Now);
            }
            catch (Exception err)
            { status.Text = err.Message; }
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            count = 1;
            timerRefresh.Stop();
            txtUid.Enabled = !false;
            groupBox3.Enabled = !false;
            btnClear.Enabled = !false;
            btnPasteUrl.Enabled = !false;
            groupBox5.Enabled = !false;
            btnStop.Enabled = !true;
            numInterval.Enabled = !false;
            tMax = -1;
            btnStart.Enabled = !false;
            status.Text = "已停止";
        }
        /// <summary>
        /// 刷新网页
        /// </summary>
        private void timerRefresh_Tick(object sender, EventArgs e)
        {
            try
            {
                string s = GetS(CGI + priUid);//更新页面源码
                int t = GetTime(s, tMax);//获取时间戳
                if (t > tMax)
                {//发现新作品,准备下载
                    status.Text = "发现新作品,准备下载";
                    Thread.Sleep(3000);//作品发上去的一瞬间,服务器上可能没有文件
                    string url = GetNew(s, tMax);
                    Console.WriteLine(url);
                    Song song = Download(url);
                    tMax = song.Time;//更新时间戳
                }
            }
            catch (Exception err)
            { status.Text = err.Message; }
            finally
            {
                count++;
                LoadMessage();
                status2.Text = string.Format("第{0}次监控 确诊:{1} 疑似:{2} 治愈:{3} 死亡:{4} 更新时间:{5}", count, confirmed, unconfirmed, cured, died, DateTime.Now);
            }
        }

        private void numInterval_ValueChanged(object sender, EventArgs e)
        {
            timerRefresh.Interval = (int)numInterval.Value;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            numTMax.Value = tMax;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            tMax = (int)numTMax.Value;
        }

        private void btnCopyUrl_Click(object sender, EventArgs e)
        {
            if (txtUid.Text.Trim() != "")
            { Clipboard.SetText(txtUid.Text.Trim()); }
        }

        private void chkClipboard_CheckedChanged(object sender, EventArgs e)
        {
            if (chkClipboard.Checked)
            {
                txtUrl.Enabled = false;
                btnPaste.Enabled = false;
                btnDownload.Enabled = false;
                btnPasteUrl.Enabled = false;
                btnCopyUrl.Enabled = false;
                timerClipBoard.Start();
                status.Text = "已启动剪切板监控功能,复制歌曲链接自动下载";
            }
            else
            {
                txtUrl.Enabled = !false;
                btnPaste.Enabled = !false;
                btnDownload.Enabled = !false;
                btnPasteUrl.Enabled = !false;
                btnCopyUrl.Enabled = !false;
                timerClipBoard.Stop();
                status.Text = "已停用剪切板监控功能";
            }
        }

        private void btnSaveImage_Click(object sender, EventArgs e)
        {
            if (pictureBox.Image == null) { return; }
            if (save.ShowDialog() == DialogResult.OK)
            {
                pictureBox.Image.Save(save.FileName);
            }
        }

        private void btnPasteUrl_Click(object sender, EventArgs e)
        {
            txtUid.Text = Clipboard.GetText();
        }

        private void btnPaste_Click(object sender, EventArgs e)
        {
            txtUrl.Text = Clipboard.GetText();
        }

        private void btnDownload_Click(object sender, EventArgs e)
        {
            Download(txtUrl.Text);
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            txtUrl.Clear();
            txtUid.Clear();
            txtRemark.Clear();
            lstInfo.Items.Clear();
            player.URL = null;
            pictureBox.Image = null;
            btnSaveImage.Enabled = false;
        }

        private void chkTop_CheckedChanged(object sender, EventArgs e)
        {
            this.TopMost = chkTop.Checked ? true : false;
        }

        private void btnAbout_Click(object sender, EventArgs e)
        {
            new FrmAbout().ShowDialog();
        }

        private void timerClipBoard_Tick(object sender, EventArgs e)
        {
            try
            {
                string temp = Clipboard.GetText();
                if (temp.Contains("node.kg.qq.com"))
                { Download(temp); }
            }
            catch (Exception err)
            { status.Text = err.Message; }
            finally { Clipboard.Clear(); }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start("explorer.exe", "https://www.52pojie.cn/");
        }

    }
}
